#include <sourcemod>
#include <sdktools>

#define DEBUG 0

#define REVIVESLOTS 7

public Plugin:myinfo =
{
	name = "L4D2 Defib-Glitch Canceller",
	author = "ArmGadge",
	description = "Avoid defibrillator glitch on multiple slots server.",
	version = "1.0.0dev3",
	url = "http://radiowave.moe.hm:774/wordpress/?page_id=476"
};

new Handle:h_charinfo = INVALID_HANDLE;
new Handle:h_corpsetoplayer = INVALID_HANDLE;
new Handle:h_playertocorpse = INVALID_HANDLE;
new Handle:h_cv_defib_duration = INVALID_HANDLE;
new Handle:h_timer_defib[MAXPLAYERS+1] = INVALID_HANDLE;
new Handle:h_timer_canceldefib[MAXPLAYERS+1] = INVALID_HANDLE;
new bool:isworking[MAXPLAYERS+1];
new String:logpath[128];
//キャラクターを保存する
new charinfo[MAXPLAYERS+1];
new restoretiming[MAXPLAYERS+1];

new reviveslot[MAXPLAYERS+1];	//除細動器の使用プレイヤーの使用スロットNo.
new revivetarget[REVIVESLOTS];	//各蘇生スロットに入っている蘇生対象のクライアントID
new defibentid[MAXPLAYERS+1]; //手持ちの除細動器のEntity ID

public OnPluginStart()
{
	//ゲームフォルダチェック
	decl String:game_name[64];
	GetGameFolderName(game_name, sizeof(game_name));
	if (!StrEqual(game_name, "left4dead2", false))
	{
		SetFailState("Plugin supports Left 4 Dead 2 only.");
	}
	
	HookEvent("round_start", Event_RoundStart);
	HookEvent("defibrillator_begin", Event_DefibrillatorBegin);
	HookEvent("defibrillator_used", Event_DefibrillatorDone);
	HookEvent("defibrillator_interrupted", Event_DefibrillatorDone);
	HookEvent("player_spawn", Event_PlayerSpawn, EventHookMode_Post);
	HookEvent("player_death", Event_PlayerDeath, EventHookMode_Post);
	//HookEvent("player_incapacitated", Event_PlayerIncapOrDeath);
	//defibrillator_used_failは生きているキャラに対して使おうとした時かかる
	h_charinfo = CreateTrie(); 
	h_corpsetoplayer = CreateTrie();
	h_playertocorpse = CreateTrie();
	h_cv_defib_duration = FindConVar("defibrillator_use_duration");
	
	BuildPath(Path_SM, logpath, sizeof(logpath), "logs/l4d2_defibglitch.log");
	LoadTranslations("plugin.l4d2_defibglitch");
	
	InitPlugin();
}

public Event_RoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	//ClearInstance();
	//ClearTrie(h_charinfo);
	InitPlugin();

	#if DEBUG
	LogToFile(logpath, "----- Round Start -----");
	#endif
}

InitPlugin()
{
	for (new i=1; i<=MaxClients; i++)
	{
		if(h_timer_defib[i] != INVALID_HANDLE)
		{
			KillTimer(h_timer_defib[i]);
			h_timer_defib[i] = INVALID_HANDLE;
		}
	}
	
	for (new i=1; i<=MaxClients; i++)
	{
		charinfo[i] = -1;
		reviveslot[i] = -1;
		restoretiming[i] = -1;
		defibentid[i] = -1;
	}
	for (new i=0; i<REVIVESLOTS; i++) revivetarget[i] = -1;
	ClearTrie(h_corpsetoplayer);
	ClearTrie(h_playertocorpse);
}

public OnPluginEnd()
{
	CloseHandle(h_charinfo);
	CloseHandle(h_corpsetoplayer);
	CloseHandle(h_playertocorpse);
}

public Event_PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	/*
		空蘇生対策、もしspawn時に死体が消えてないようなら消す
		クローゼット救出の時、本物以外は死体が消えてない
		SM Respawnプラグインで無理やり復活させたときには死体が消えない　player_spawnトリガーかかるので仮利用
		死亡中にプレイヤーの入れ替えがあるとちょっとマズイかも
	*/
	new uid_player = GetEventInt(event, "userid");
	new cid_player = GetClientOfUserId(uid_player);
	decl String:str_cid[8];
	decl String:str_corpseid[8];
	IntToString(cid_player, str_cid, sizeof(str_cid));
	new corpseid;

	if ((GetClientTeam(cid_player) == 2) && (GetTrieSize(h_corpsetoplayer) != 0))
	{
		if (GetTrieValue(h_playertocorpse, str_cid, corpseid))
		{
			if (IsValidEntity(corpseid))
			{
				RemoveEdict(corpseid);
				#if DEBUG
				LogToFile(logpath, "Removed corpse %d.", corpseid);
				#endif
			}
			IntToString(corpseid, str_corpseid, sizeof(str_corpseid));
			RemoveFromTrie(h_corpsetoplayer, str_corpseid);
			RemoveFromTrie(h_playertocorpse, str_cid);
			#if DEBUG
			LogToFile(logpath, "Unlinked: client %d <--> corpse %d.", cid_player, corpseid);
			#endif
		}
	}

}

public OnClientDisconnect_Post(client)
{
	/*
		死体とリンクしてる人が抜けた時、クライアントが消失が起き、
		存在しないクライアントがターゲットになって空蘇生するバグの修正
		とりあえず死体を消してアンリンクしてしまおう
		todo:引継ぎできるようなら引き継ぎ処理の追加
	*/

	decl String:str_cid[4], String:str_corpseid[8];
	new corpseid;
	IntToString(client, str_cid, sizeof(str_cid));	
	if (GetTrieValue(h_playertocorpse, str_cid, corpseid))
	{
		#if DEBUG
		LogToFile(logpath, "Linked client %d has disconnected, start unlinking.", client);
		#endif		
		
		if (IsValidEntity(corpseid))
		{
			RemoveEdict(corpseid);
			#if DEBUG
			LogToFile(logpath, "Removed corpse %d.", corpseid);
			#endif
		}
		IntToString(corpseid, str_corpseid, sizeof(str_corpseid));
		RemoveFromTrie(h_corpsetoplayer, str_corpseid);
		RemoveFromTrie(h_playertocorpse, str_cid);
		#if DEBUG
		LogToFile(logpath, "Unlinked: client %d <--> corpse %d.", client, corpseid);
		#endif
	}

}

public Event_DefibrillatorBegin(Handle:event, const String:name[], bool:dontBroadcast)
{
	new uid_player = GetEventInt(event, "userid");
	new cid_player = GetClientOfUserId(uid_player);
	new uid_subject = GetEventInt(event, "subject");
	new cid_subject = GetClientOfUserId(uid_subject);
	//subjectは対象キャラの中でクライアントIDの一番小さい人の値が取れる。あてにならない
	
	/*
		作業中にダウンしたり死亡すると、defibrillator_interruptedが掛からないみたい
		他にも特殊感染者に襲われたりだとか、近くでプロパンが爆発してひるんだりするとか。該当パターンがかなりある
		めんどいからタイムアウトを設定する。
	*/
	/*
		new String:entname[32];
		new ent = GetPlayerWeaponSlot(cid_player, 3);
		GetEdictClassname(ent, entname, sizeof(entname));
	*/
	//new tgt = GetEntPropEnt(ent, Prop_Send, "m_helpingHandTarget");
	
	/*
	new String:szn[32], String:mt[32];
	new szn2=GetEntPropEnt(ent, Prop_Data, "m_iszName");
	new mt2=GetEntPropEnt(ent, Prop_Data, "m_target");
	PrintToChatAll("%d:%s tgt:%d %d %d", ent, entname, tgt, szn2, mt2);
*/
	
	//new rvo = GetEntPropEnt(cid_player, Prop_Send, "m_reviveOwner");
	//new rvt = GetEntPropEnt(cid_player, Prop_Send, "m_reviveTarget");
	//new uao =GetEntPropEnt(cid_player, Prop_Send, "m_useActionOwner");
	new uat = GetEntPropEnt(cid_player, Prop_Send, "m_useActionTarget");
	//new rvo = GetEntPropEnt(ent, Prop_Send, "m_hOwner");
	//new rvt = GetEntPropEnt(ent, Prop_Send, "m_hEffectEntity");

	//uatで死体モデルが取れる
	//PrintToChatAll("%d %d %d %d", rvo,rvt,uao,uat);

	/*
	if(h_timer_defib != INVALID_HANDLE)
	{
		KillTimer(h_timer_defib);
	}
	h_timer_defib = CreateTimer(float(GetConVarInt(h_cv_defib_duration)+1), OnTimeOut);
	*/
	new offset = FindSendPropInfo("CTerrorPlayer", "m_survivorCharacter");
	new char_subject = GetEntData(cid_subject, offset, 1);

	
	new tmp_int;
	new char_slot = -1;
	new bool:usingslot[REVIVESLOTS];
	new slotcount;
	isworking[cid_player] = true;
	
	//同じ使用キャラが既に蘇生スロットを使っている場合は解放する。蘇生完了のイベントが発行されない時の対策
	if (h_timer_defib[cid_player] != INVALID_HANDLE)
	{
		KillTimer(h_timer_defib[cid_player]);
		RestoreCharacter(cid_player);
		#if DEBUG
		LogToFile(logpath, "Client %d is already using revive slot, restored.",
			cid_player);
		#endif
		h_timer_defib[cid_player] = INVALID_HANDLE;
	}
	
	//蘇生用スロットの確認
	for (new j=1; j<=MaxClients; j++)
	{
		if (reviveslot[j] != -1)
		{	
			usingslot[reviveslot[j]] = true;
			slotcount++;
		}
	}	
#if DEBUG
	new String:slotstate[REVIVESLOTS];
	for (new i=0; i<REVIVESLOTS; i++)
	{
		if (usingslot[i] == true)
			slotstate[i] = 'x';
		else slotstate[i] = 'o';
	}
	LogToFile(logpath, "%d slots using, free slot: %s", slotcount, slotstate);
#endif
	
	for (new i=0; i<REVIVESLOTS; i++)
	{
		if(usingslot[i] == false)
		{
			char_slot = i;
			break;
		}
	}	
	#if DEBUG
	LogToFile(logpath, "will use slot #%d.", char_slot);
	#endif
	//蘇生対象の死体-チェック
	new String:str_corpseid[8];
	new cid_tsubject;
	new char_tsubject;
	IntToString(uat, str_corpseid, sizeof(str_corpseid));
	if (GetTrieValue(h_corpsetoplayer, str_corpseid, cid_tsubject))
	{
		#if DEBUG
		LogToFile(logpath, "Found corpse id %d - client %d", uat, cid_tsubject);
		#endif	
		/*
			どうやら複数プレイヤーが同時に同じ死体を蘇生できるらしい。空蘇生が起きるので対策
		*/
		for (new i=0; i<REVIVESLOTS; i++)
		{
			if(cid_tsubject == revivetarget[i])
			{
				new Handle:pack;
				h_timer_canceldefib[cid_player] =
					CreateDataTimer(float(GetConVarInt(h_cv_defib_duration)),
						OnCancelDefib, pack);
				new ent = GetPlayerWeaponSlot(cid_player, 3);
				if (ent != -1)
				{
					RemovePlayerItem(cid_player, ent);
					WritePackCell(pack, cid_player);
					WritePackCell(pack, ent);
					PrintToChat(cid_player, "\x04[DGC] %t", "OtherPlayerReviving");
					#if DEBUG
					LogToFile(logpath, "Client %d: Subject %d is already being revived by other player.",
						cid_player, cid_tsubject);
					#endif	
				}

				return;
			}
		}
		
		h_timer_defib[cid_player] =
			CreateTimer(float(GetConVarInt(h_cv_defib_duration)+1), OnTimeOut, cid_player);
		
		//蘇生情報の保存
		reviveslot[cid_player] = char_slot;
		revivetarget[char_slot] = cid_tsubject;
		//charinfo[cid]でいいじゃん
		//reviveinfo[cid_player][2] = char_tsubject;
		
		if (++slotcount == REVIVESLOTS) SetDefibAvailability(false);
		#if DEBUG
		LogToFile(logpath, "Defib begin: slotcount = %d, p = cid:%d(uid:%d), s = cid:%d(uid:%d), reviveslot = %d",
			slotcount, cid_player, uid_player, cid_subject, uid_subject, char_slot);
		#endif
		
		PrintToChatAll("\x03[DGC] %t", "Avoiding", slotcount);
		
		//移動先キャラクターの決定
		
		for (new i=1; i<cid_tsubject; i++)
		{
			if (IsClientConnected(i) &&	IsClientInGame(i) && (GetClientTeam(i) == 2))
			{
				new char = GetEntData(i, offset, 1);

				//蘇生スロットと同じ場合
				if (char == char_slot) 
				{
					/*
						キャラ設定を保存　既に保存されている場合は保存しない。
						退避スロットに既に入ってる場合は退避用スロットの値が保存されてしまうので
					*/
					charinfo[i] = char;
					//PushArrayCell(h_restorequeue[char_slot], i);
					restoretiming[i] = char_slot;
					
					#if DEBUG
					LogToFile(logpath, "ChangeChar: client %d %d->7",i, char);
					#endif
					
					//中の人だけずらす（1人称モデルと声とアイコンが変更される）
					SetEntData(i, offset, 7, 1, true);
				}

			}
		}
		#if DEBUG
		LogToFile(logpath, "Store done.");
		#endif
		
		//本物の蘇生ターゲットが退避用スロットにいる場合は保存しない。
		if (charinfo[cid_tsubject] == -1)
		{
			charinfo[cid_tsubject] = GetEntData(cid_tsubject, offset, 1);
		}
		//復元タイミングの設定
		//蘇生対象が退避スロットにいる場合、タイミングの移動が発生する
		restoretiming[cid_tsubject] = char_slot;
		//本物の蘇生ターゲットを蘇生用キャラにずらす
		//Botに対して行うと表示名も変わってしまうので、蘇生対象の表示が蘇生スロットとして使ってるキャラ名になる。
		SetEntData(cid_tsubject, offset, char_slot, 1, true);

		//死体のキャラクター設定を蘇生用キャラにずらす
		SetEntProp(uat, Prop_Send, "m_nCharacterType", char_slot);	

		#if DEBUG
		LogToFile(logpath, "ChangeChar: subject client %d %d->%d",cid_tsubject, charinfo[cid_tsubject], char_slot);
		#endif
		
		decl String:pname[64];
		if (IsFakeClient(cid_tsubject))
		{
			
			GetClientName(cid_tsubject, pname, sizeof(pname));
			PrintToChat(cid_player, "\x03[DGC] %t", "RevivingBot", pname);
		}
		else 
		{
			GetClientName(cid_player, pname, sizeof(pname));
			PrintToChat(cid_tsubject, "\x03[DGC] %t", "BeingRevived", pname);
		}
	}
	else
	{
		#if DEBUG
		LogToFile(logpath, "Error: corpse ID not found");
		#endif	
	}
}

public Event_DefibrillatorDone(Handle:event, const String:name[], bool:dontBroadcast)
{
	new uid_player = GetEventInt(event, "userid");
	new cid_player = GetClientOfUserId(uid_player);
	new uid_subject = GetEventInt(event, "subject");
	new cid_subject = GetClientOfUserId(uid_subject);
	
	new offset = FindSendPropInfo("CTerrorPlayer", "m_survivorCharacter");
	new char = GetEntData(cid_subject, offset, 1);
	
	isworking[cid_player] = false;	
	
	#if DEBUG
	LogToFile(logpath, "Defib done (%s): p = cid:%d(uid:%d), s = cid:%d(uid:%d)",
		name, cid_player, uid_player, cid_subject, uid_subject);
	#endif
	
	RestoreCharacter(cid_player);
	
	if (h_timer_defib[cid_player] != INVALID_HANDLE)
	{
		KillTimer(h_timer_defib[cid_player]);
		h_timer_defib[cid_player] = INVALID_HANDLE;
	}
}

//キャラ設定復元
RestoreCharacter(cid_player)
{
	#if DEBUG
	LogToFile(logpath, "RestoreChar Begin");
	#endif	
	new offset = FindSendPropInfo("CTerrorPlayer", "m_survivorCharacter");
	
	//蘇生情報の取り出し
	new char_slot = reviveslot[cid_player];
	//corpse IDがない場合は回避してないから復元できないので処理中止する
	if (char_slot == -1) return;
	new cid_tsubject = revivetarget[char_slot];
	//new char_tsubject = reviveinfo[cid_player][2]; 
	
	//先にスロットを解放しておいていいか
	reviveslot[cid_player] = -1;
	revivetarget[char_slot] = -1;
	
	/*
		復元タイミングが該当スロットなら復元を行う
		戻り先のスロットが使用中の場合は退避してタイミングを戻り先のスロットに合わせる
	*/

	//蘇生用スロットの確認
	new bool:usingslot[REVIVESLOTS] = false;
	new count_slotusing;
	for (new j=1; j<=MaxClients; j++)
	{
		if (reviveslot[j] != -1)
		{	
			usingslot[reviveslot[j]] = true;
			count_slotusing++;
		}
	}
	
#if DEBUG
	new String:slotstate[REVIVESLOTS];
	for (new i=0; i<REVIVESLOTS; i++)
	{
		if (usingslot[i] == true)
			slotstate[i] = 'x';
		else slotstate[i] = 'o';
	}
	LogToFile(logpath, "%d slots using, free slot: %s", count_slotusing, slotstate);
#endif

	for (new i=1; i<=MaxClients; i++)
	{
		if ((restoretiming[i] == char_slot) &&
			IsClientConnected(i) &&
			IsClientInGame(i) &&
			(GetClientTeam(i) == 2))
		{
			#if DEBUG
			LogToFile(logpath, "client %d: restoretiming %d, savedchar %d",
				i, restoretiming[i], charinfo[i]);
			#endif
			//スロットが空いてるかチェック
			//ルイスは退避スロットだから、常時移して大丈夫。
			if (charinfo[i] != 7 && usingslot[charinfo[i]] == true)
			{
				restoretiming[i] = charinfo[i];
				SetEntData(cid_tsubject, offset, 7, 1, true);
				#if DEBUG
				LogToFile(logpath, "client %d: charID %d is using, retreating to charid 7. changed timing:%d",
					i, charinfo[i], charinfo[i]);
				#endif	
			}
			else
			{
				restoretiming[i] = -1;
				SetEntData(i, offset, charinfo[i], 1, true);
				#if DEBUG
				LogToFile(logpath, "client %d: charID %d is vacant, restored.",
					i, charinfo[i]);
				#endif	
			}
		}
	}

	/*
	for (new i=1; i<cid_tsubject; i++)
	{
		if ((charinfo[i] == char_slot) && 
			IsClientConnected(i) &&
			IsClientInGame(i) &&
			(GetClientTeam(i) == 2))
		{
			SetEntData(i, offset, charinfo[i], 1, true);
			charinfo[i] = -1;
		}
	}
	
	SetEntData(cid_tsubject, offset, char_tsubject, 1, true);
	*/
	if (count_slotusing == REVIVESLOTS-1) SetDefibAvailability(true);
	
	if (count_slotusing == 0)
		PrintToChatAll("\x03[DGC] %t", "AvoidingDone");
	//else PrintToChatAll("\x03[DGC] %t", "Avoiding", count_slotusing);
	/*
	new charcode;
	new String:strbuf[4];
	
	for (new i=1; i<=MaxClients; i++)
	{
		if (IsClientConnected(i) && IsClientInGame(i) && (GetClientTeam(i) == 2))
		{
			IntToString(i, strbuf, sizeof(strbuf));
			if (GetTrieValue(h_charinfo, strbuf, charcode))
			{
				SetEntData(i, offset, charcode, 1, true);
				RemoveFromTrie(h_charinfo, strbuf);
				#if DEBUG
				LogToFile(logpath, "Restored setting: cid:%d (charcter %d)", i, charcode);
				#endif
				PrintToChat(i, "\x03Defib glitch avoidance deactivated.");
			}
		}
	}
	#if DEBUG
	LogToFile(logpath, "Restore done.");
	#endif
	*/
}

public Action:OnTimeOut(Handle:timer, any:cid_player)
{
	#if DEBUG
	LogToFile(logpath, "Timed Out: force restored.");
	#endif
	RestoreCharacter(cid_player);
	h_timer_defib[cid_player] = INVALID_HANDLE;
	/*
	h_timer_defib = INVALID_HANDLE;
	RestoreCharacter();
	ClearInstance();
	ClearTrie(h_charinfo);
	*/

}

// あらぬタイミングでキャンセルがキャンセルされるのを防ぐため、SetDefibAvailabilityとは別系統にしてる
public Action:OnCancelDefib(Handle:timer, Handle:pack)
{
	decl String:entname[32];
	ResetPack(pack);
	new cid_player = ReadPackCell(pack);
	new ent = ReadPackCell(pack);
	if (IsClientConnected(cid_player) &&
		IsClientInGame(cid_player) &&
		(GetClientTeam(cid_player) == 2))
	{
		if (IsValidEntity(ent))
		{
			GetEdictClassname(ent, entname, sizeof(entname));
			if (StrEqual(entname, "weapon_defibrillator", false))
				EquipPlayerWeapon(cid_player, ent);
		}
	}	
	h_timer_canceldefib[cid_player] = INVALID_HANDLE;
}

//除細動器の有効・無効切り替え
SetDefibAvailability(bool:value)
{
	new String:entname[32];
	if (value)
	{
		for (new i=1; i<=MaxClients; i++)
		{
			if (IsClientConnected(i) &&	IsClientInGame(i) && (GetClientTeam(i) == 2))
			{
				if (defibentid[i] != -1 && IsValidEntity(defibentid[i]))
				
				{
					GetEdictClassname(defibentid[i], entname, sizeof(entname));
					if (StrEqual(entname, "weapon_defibrillator", false))
						EquipPlayerWeapon(i, defibentid[i]);
				}
				defibentid[i] = -1;
			}
		}
		PrintToChatAll("\x03[DGC] %t", "DefibAvailable");
	}
	else
	{
		for (new i=1; i<=MaxClients; i++)
		{
			//除細動器を持ってて今使ってない人がいたら奪う
			if (IsClientConnected(i) &&	IsClientInGame(i) && (GetClientTeam(i) == 2) &&
				(reviveslot[i] == -1))
			{
				new ent = GetPlayerWeaponSlot(i, 3);
				if(ent != -1 && IsValidEntity(ent))
				{
					GetEdictClassname(ent, entname, sizeof(entname));
					if (StrEqual(entname, "weapon_defibrillator", false))
					{
						defibentid[i] = ent;
						RemovePlayerItem(i, ent);
					}
				}
			}
		}
		PrintToChatAll("\x04[DGC] %t", "DefibNotAvailable");
	}
}



//死体位置の修正とマーキング
/*
todo:死体がある時にプラグインがロードされると正常に動かない。どうするか。
死体を消してしまう
適当に埋める
*/
public Event_PlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	new uid_player = GetEventInt(event, "userid");
	new cid_player = GetClientOfUserId(uid_player);
	new String:strbuf[16];
	decl String:str_entid[8];
	decl String:str_cid[8];

	if (cid_player &&
		IsClientConnected(cid_player) &&
		IsClientInGame(cid_player) &&
		(GetClientTeam(cid_player) == 2)
	)
	{
		new offset = FindSendPropInfo("CTerrorPlayer", "m_survivorCharacter");
		new char_player = GetEntData(cid_player, offset, 1);
		new tmp_char;
		new cid_parentchar;
		new ent = -1;
		for (new i=1; i<cid_player; i++)
		{
			if (IsClientConnected(i) &&
				IsClientInGame(i) &&
				(GetClientTeam(i) == 2)
			)
			{
				tmp_char = GetEntData(i, offset, 1);
				if (tmp_char == char_player)
				{
					cid_parentchar = i;
					break;
				}
			}
		}
		//cid_parentcharが0なら死亡プレイヤーが親キャラなのでマーキングだけしておく
		//死体Entityを探索
		while((ent = FindEntityByClassname(ent, "survivor_death_model")) != -1)
		{
			if(IsValidEntity(ent))
			{
				//マーキングチェック
				new tmpval;
				IntToString(ent, str_entid, sizeof(str_entid));
				IntToString(cid_player, str_cid, sizeof(str_cid));
				if (!GetTrieValue(h_corpsetoplayer, str_entid, tmpval))
				{
					//死体Entity ID⇔プレイヤーIDを対応付け
					SetTrieValue(h_corpsetoplayer, str_entid, cid_player);
					SetTrieValue(h_playertocorpse, str_cid, ent);
					#if DEBUG
					LogToFile(logpath, "Linked: client %d <--> corpse %d.", cid_player, ent);
					#endif
					//new tst = GetEntProp(ent, Prop_Send, "m_nCharacterType");
					//PrintToChatAll("charid is %d", tst);
					//The sacrifice アップデート以降、親も移動の対象とする
					//正しい位置へ移動
					new Float:pos_player[3], Float:angle_player[3], Float:vec_player[3];
					GetClientAbsOrigin(cid_player, pos_player);
					GetClientAbsAngles(cid_player, angle_player);
					GetEntPropVector(cid_player, Prop_Data, "m_vecVelocity", vec_player);
					TeleportEntity(ent, pos_player, angle_player, vec_player);

					/*↑のthe sacrifice アップデート以前*/
					/*
					if (cid_parentchar)
					{
						//正しい位置へ移動
						new Float:pos_player[3], Float:angle_player[3], Float:vec_player[3];
						GetClientAbsOrigin(cid_player, pos_player);
						GetClientAbsAngles(cid_player, angle_player);
						GetEntPropVector(cid_player, Prop_Data, "m_vecVelocity", vec_player);
						
						TeleportEntity(ent, pos_player, angle_player, vec_player);
					}
					*/
					break;

				}
				/*
				GetEntPropString(ent, Prop_Data, "m_iName", iname, sizeof(iname));	

				if(StrContains(iname, "client", false) == -1)
				{
					//マーキング
					
					Format(strbuf, sizeof(strbuf), "client%d", cid_player);
					DispatchKeyValue(ent, "targetname", strbuf);
					
					if (cid_parentchar)
					{
						//正しい位置へ移動
						new Float:pos_player[3], Float:angle_player[3], Float:vec_player[3];
						GetClientAbsOrigin(cid_player, pos_player);
						GetClientAbsAngles(cid_player, angle_player);
						GetEntPropVector(cid_player, Prop_Data, "m_vecVelocity", vec_player);
						
						TeleportEntity(ent, pos_player, angle_player, vec_player);
					}
					break;
				}
				*/
			}
		}
	}
}
